{#-#####################################################################
 # Helper macros dealing with interface devices
 ####################################################################-#}
{#======================================================================
 # Generate interface final device name
 #----------------------------------------------------------------------
 # Echoes the final device name of the supplied interface, i.e. the
 # name of the interface backing device **after** interface renaming
 # took place.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #
 # If the supplied interface is not configured to be renamed, or if
 # interface renaming is not supported by the remote plateform, this
 # macro will fallback to the native device name for the interface.
 #===================================================================-#}
{%- macro generate_interface_final_device_name(interface) -%}
  {#- Shortcut variables -#}
  {%- set interface_type    = interface['type'] -%}
  {%- set interface_name    = interface['name'] -%}
  {%- set interface_renamed = interface['renamed'] -%}

  {#- Load interface renaming support options -#}
  {%- set renaming_is_supported =
      role__sys_net_interfaces__framework_options['features'][
      'interface_renaming'] -%}

  {#- Default value is set to the native device name -#}
  {%- set final_device_name =
      generate_interface_native_device_name(interface) -%}

  {#- If the interface is configured for device renaming, and renaming
   #  is supported by the network framework for this interface type -#}
  {%- if interface_renamed and interface_name is not sameas None and
         renaming_is_supported[interface_type]
  -%}
    {%- set final_device_name = interface['name'] -%}
  {%- endif -%}

  {{ final_device_name }}
{%- endmacro -%}

{#======================================================================
 # Generate interface native device name
 #----------------------------------------------------------------------
 # Echoes the native device name of the supplied interface on the
 # targeted platform.
 #
 # Parameters:
 #    - interface (dict) An interface definition
 #
 # If the interface is an adapter, this macro will echo the device name
 # of the physical backing device. It the interface is virtual (bond,
 # bridge, vlan...), the macro will build a standard device name using
 # standard device prefixes on the remote platform, and the interface
 # index number.
 #===================================================================-#}
{%- macro generate_interface_native_device_name(interface) -%}
  {#- Shortcut variables -#}
  {%- set interface_type = interface['type'] -%}
  {%- set device_prefixes =
      role__sys_net_interfaces__platform_options[
        'idioms']['device_prefixes'] -%}

  {#- Adapter interfaces use their device name as their native name -#}
  {%- if interface_type == 'adapter' -%}
    {{ interface['adapter']['device'] }}

  {#- Virtual interfaces build their native name from a device prefix
   #  and an index number. -#}
  {%- else -%}
    {%- set interface_index = interface[interface_type]['index']-%}
    {{ device_prefixes[interface_type] ~ interface_index | int }}
  {%- endif -%}
{%- endmacro -%}
